/*****************************************************************************

	Felix IRC client Add-ons architecture sample code

	DCC Add-ons APIs.
	You have to know DCC protocol to make dcc addons. 
	
	- in order to have prefs for each addon, the addon must create a BView.
	  the view must be 233x228 and support its own BMessages.
	  The view won't be resized.
	  The addon must manage itself to save the data in a file.
	  the file path must be "/boot/home/config/settings/Felix/"

	* init function : It return the BView. This function is the same for all
	  AddOns (global, action and dcc).
	  The BView can be NULL. In that case, a default view will be created.
	  The function takes a BList in parameter, it should fill it with dcc type supported by the add-on.
	  For example a Dcc send add on should also support dcc resume. The item in the BList should be
	  allocated char* string.
	  All the supported type will create a BMenu entry.

	How does that work :
	2 main functions:
	* SendDcc() -> use to initiate a dcc
		This function receive some useful stuff from the app
		- the type of dcc action to perform (if you support only one type, ignore it)
		- the IP
		- the Port the addon will listen to (it's given by the apps to avoid conflict
		  among different DCC add-ons.
		- The name of the user to send the request
		- A Looper. You must send you request to this looper. The message must be a
		  valid RAW IRC message	, and the BMessage must follow these rules :

			name		type			value
			"what"		B_INT32_TYPE	'Imsg'
			"IrcRaw"	B_STRING_TYPE	Your irc string

	* ProcessDcc()
		This function receive directly the dcc request string (without the '\1')
		DCC type argument address port
		If the add on is not able to handle the request (bad type) it must return false.
		If it handles the request it must return true off course.
		In that way, an addon can handle several sorts of request
		
	Support for drag'n'drop. To support drag'n'drop of file directly to channel window,
	the add-on must specifie if it supports file, by returning true to FileSupport() call.
	It should also implement the 2nd version of SendDcc which received an additionnal
	parameter : an entry_ref*
	
	For more information : ducrohet@club-internet.fr
	


*****************************************************************************/

/*
 * Sorry there is no example for dcc currently
 */


#pragma export on
extern "C" BView*	AddOnInit(BList *);
extern "C" void	AddOnTerminate(void);
extern "C" void	SendDcc(const char *type,uint32 ip, int32 port, const char *user, BLooper *server);
extern "C" void	SendDcc_ref(const char *type,uint32 ip, int32 port, const char *user, BLooper *server, entry_ref *ref);
extern "C" void	ProcessDcc(const char *user, const char *request, BLooper *server);
extern "C" bool	SupportFile(void);
#pragma export reset


BView * AddOnInit(BList *l) {
}

void AddOnTerminate(void) {
}



void SendDcc(const char */*type*/,uint32 ip, int32 port, const char *user, BLooper *server) {
}

void	SendDcc_ref(const char */*type*/,uint32 /*ip*/, int32 /*port*/, const char */*user*/, BLooper */*server*/, entry_ref */*ref*/) {
}

void	ProcessDcc(const char *from, const char *request, BLooper *server) {

}

bool SupportFile(void) {
	return false;
}
