// Class LogLooper
// © Ducrohet 1997
// Main goal : add-ons for Felix 2.1

#include "LogLooper.h"

extern BDirectory log_f;

LogLooper::LogLooper(const char * name,BLooper *sender)
				: BLooper("",B_NORMAL_PRIORITY) {
	Sender = sender;


	status_t erreur;
	Log = new BFile();
	int32 i=1;
	do {
		char realname[B_PATH_NAME_LENGTH];
		if (i>1) {
			sprintf(realname,"%s#%d",name,i++);
			erreur = log_f.CreateFile(realname,Log,true);
		}
		else {
			erreur = log_f.CreateFile(name,Log,true);
			i++;
		}
	}while (erreur != B_NO_ERROR);



	char buf[512];
	time_t temps;

	time(&temps);
	sprintf(buf,"%s, %s\n",name,ctime(&temps));
	Log->Write(buf,strlen(buf));

	// launch the looper
	// with the good name
	char Name[256];
	sprintf(Name,"%s log",name);
	rename_thread (Run (), Name);
}


void LogLooper::MessageReceived(BMessage *message) {
	char *msg;

	switch (message->what) {
		// reception d'une chaine a envoyer
		case 'Imsg' :
			if (message->FindString("IrcRaw",&msg)==B_NO_ERROR) {
				Log->Write(msg,strlen(msg));
				Log->Write("\n",1);
			}
			break;
	}
}


bool LogLooper::QuitRequested(void) {
	// set the mime type
	BNodeInfo info(Log);
	info.SetType("text/plain");
	delete Log;
	return true;
}


