// Pref view for Log addon

#include "PrefView.h"

extern bool enable_log;
extern BDirectory log_f;

PrefView::PrefView(	BRect frame,const char *name,uint32 resizeMask,uint32 flags)
	:BView (frame,name,resizeMask,flags) {

	SetViewColor(210,210,210);
	BStringView *titre = new BStringView(BRect(20,10,230,30),"text","Log 0.2.1");
	AddChild(titre);
	titre = new BStringView(BRect(20,30,230,45),"text"," © Copyright 1996-1997 Xavier Ducrohet");
	AddChild(titre);
	titre = new BStringView(BRect(20,45,230,60),"text","All Rights Reserved");
	AddChild(titre);
	titre = new BStringView(BRect(20,70,230,85),"text","Log all the IRC message received and sent.");
	AddChild(titre);

	enable = new BCheckBox(BRect(20,100,Bounds().right-20,120),"Enable log","Enable log of connections",new BMessage('enbl'));
	enable->SetValue(enable_log);
	AddChild(enable);
	
	trash = new BButton(BRect(20,170,Bounds().right-20,190),"MoveToTrash","Move all logs to trash",new BMessage('trsh'));
	AddChild(trash);

	browse = new BButton(BRect(20,200,Bounds().right-20,220),"Browse","Browse all logs",new BMessage('brws'));
	AddChild(browse);
}

void PrefView::AttachedToWindow(void) {
	trash->SetTarget(this);
	browse->SetTarget(this);
	enable->SetTarget(this);
}



void PrefView::MessageReceived(BMessage *message) {
	BEntry entree;
	BPath path;
	BDirectory trash;
	entry_ref ref;

	BMessenger *tracker;
	BMessage *msg;
	status_t error;


	switch (message->what) {
		case 'trsh' :
			find_directory(B_TRASH_DIRECTORY,&path);
			trash.SetTo(path.Path());
			// move all log files to trash
			log_f.Rewind();
			while (log_f.GetNextEntry(&entree)!=ENOENT) {
				entree.MoveTo(&trash,NULL,true);
			}
			break;
		case 'brws' :
			log_f.GetEntry(&entree);
			entree.GetRef(&ref);
			tracker = new BMessenger("application/x-vnd.Be-TRAK",-1,&error);
			if (error!=B_OK) {
				(new BAlert("Ouch","Tracker Error!!","Ouch!"))->Go();
				break;
			}
			msg = new BMessage(B_REFS_RECEIVED);
			msg->AddRef("refs",&ref);
			tracker->SendMessage(msg);
			delete msg;
			delete tracker;
			break;
		case 'enbl' :
			enable_log = (enable->Value()==B_CONTROL_ON);
			break;
		default:
			BView::MessageReceived(message);
	}

}